osg::TemplateValueObject< T > Class Template Reference

`#include <ValueObject>`

Inheritance diagram for osg::TemplateValueObject< T >:

## Public Member Functions

| TemplateValueObject ()
| TemplateValueObject (const T &value)
| TemplateValueObject (const std::string &name, const T &value)
| TemplateValueObject (const TemplateValueObject &rhs, const osg::CopyOp copyop=osg::CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
void | setValue (const T &value)
const T & | getValue () const
virtual bool | get (GetValueVisitor &gvv) const
virtual bool | set (SetValueVisitor &svv)
Public Member Functions inherited from osg::ValueObject
| ValueObject ()
| ValueObject (const std::string &name)
| ValueObject (const ValueObject &rhs, const osg::CopyOp copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osg, ValueObject) virtual ValueObject *asValueObject()
virtual const ValueObject * | asValueObject () const
template<typename T>
bool | getScalarValue (T &value)
template<typename T>
bool | setScalarValue (T value)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~TemplateValueObject ()
Protected Member Functions inherited from osg::ValueObject
virtual | ~ValueObject ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

T | _value
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Static Protected Attributes

static const char * | s_TemplateValueObject_className

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Constructor & Destructor Documentation

## TemplateValueObject() [1/4]

template<typename T>

osg::TemplateValueObject< T >::TemplateValueObject | ( |  | ) |

inline

References _value, and osg::ValueObject::ValueObject().

Referenced by clone(), cloneType(), isSameKindAs(), and TemplateValueObject().

## TemplateValueObject() [2/4]

template<typename T>

osg::TemplateValueObject< T >::TemplateValueObject | ( | const T & | value | ) |

inline

References _value, and osg::ValueObject::ValueObject().

## TemplateValueObject() [3/4]

template<typename T>

osg::TemplateValueObject< T >::TemplateValueObject | ( | const std::string & | name,
|  | const T & | value )

inline

References _value, and osg::ValueObject::ValueObject().

## TemplateValueObject() [4/4]

template<typename T>

osg::TemplateValueObject< T >::TemplateValueObject | ( | const TemplateValueObject< T > & | rhs,
|  | const osg::CopyOp | copyop = osg::CopyOp::SHALLOW_COPY )

inline

References _value, osg::CopyOp::SHALLOW_COPY, TemplateValueObject(), and osg::ValueObject::ValueObject().

## ~TemplateValueObject()

template<typename T>

virtual osg::TemplateValueObject< T >::~TemplateValueObject | ( |  | ) |

inline protected virtual

## Member Function Documentation

## className()

template<typename T>

virtual const char * osg::TemplateValueObject< T >::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

References osg::ValueObjectClassNameTrait< T >::className().

## clone()

template<typename T>

virtual Object * osg::TemplateValueObject< T >::clone | ( | const CopyOp & |  | ) | const

inline virtual

Clone an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References TemplateValueObject().

## cloneType()

template<typename T>

virtual Object * osg::TemplateValueObject< T >::cloneType | ( |  | ) | const

inline virtual

Clone the type of an object, with Object* return type. Must be defined by derived classes.

Implements osg::Object.

References TemplateValueObject().

## get()

template<typename T>

virtual bool osg::TemplateValueObject< T >::get | ( | GetValueVisitor & | gvv | ) | const

inline virtual

Reimplemented from osg::ValueObject.

References _value, and osg::ValueObject::GetValueVisitor::apply().

## getValue()

template<typename T>

const T & osg::TemplateValueObject< T >::getValue | ( |  | ) | const

inline

References _value.

## isSameKindAs()

template<typename T>

virtual bool osg::TemplateValueObject< T >::isSameKindAs | ( | const Object * | obj | ) | const

inline virtual

Reimplemented from osg::Object.

References NULL, and TemplateValueObject().

## libraryName()

template<typename T>

virtual const char * osg::TemplateValueObject< T >::libraryName | ( |  | ) | const

inline virtual

return the name of the object's library. Must be defined by derived classes. The OpenSceneGraph convention is that the namespace of a library is the same as the library name.

Implements osg::Object.

## set()

template<typename T>

virtual bool osg::TemplateValueObject< T >::set | ( | SetValueVisitor & | svv | ) |

inline virtual

Reimplemented from osg::ValueObject.

References _value, and osg::ValueObject::SetValueVisitor::apply().

## setValue()

template<typename T>

void osg::TemplateValueObject< T >::setValue | ( | const T & | value | ) |

inline

References _value.

## Member Data Documentation

## _value

template<typename T>

T osg::TemplateValueObject< T >::_value

protected

Referenced by get(), getValue(), set(), setValue(), TemplateValueObject(), TemplateValueObject(), TemplateValueObject(), and TemplateValueObject().

## s_TemplateValueObject_className

template<typename T>

const char* osg::TemplateValueObject< T >::s_TemplateValueObject_className

static protected

The documentation for this class was generated from the following file:

- ValueObject